## gall 1.1

=== debian/changelog ===
gall (1.1-2) unstable; urgency=medium

  * Fix homepage URL to the git server for Gall.

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Thu, 27 Oct 2016 15:21:07 +0900

gall (1.1-1) unstable; urgency=medium

  * Initial packaging of Gall as a separate project.
  * Closes: #840724

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Fri, 14 Oct 2016 10:56:18 +0900
