=== debian/changelog ===
gall (1.2-1) unstable; urgency=medium

  * New upstream version, uses git_libgit2_init()

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Thu, 26 Jan 2017 00:00:16 +0000
