=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@ --buildsystem=lua --with lua

override_dh_auto_build:
	dh_auto_build
	ldoc --date $(SOURCE_DATE_EPOCH) .

override_dh_auto_clean:
	dh_auto_clean
	$(RM) -r html
