=== debian/changelog ===
gall (1.3-1build3) focal; urgency=medium

  * No-change rebuild against libgit2-28

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 30 Nov 2019 06:21:53 +0000

gall (1.3-1build2) cosmic; urgency=medium

  * No-change rebuild against latest libgit2

 -- Chris Coulson <chris.coulson@canonical.com>  Wed, 30 May 2018 21:45:19 +0000

gall (1.3-1build1) bionic; urgency=medium

  * No-change rebuild against latest libgit2

 -- Jeremy Bicha <jbicha@ubuntu.com>  Fri, 27 Oct 2017 13:42:59 -0400

gall (1.3-1) unstable; urgency=medium

  * New upstream version

 -- Daniel Silverstone <dsilvers@digital-scurf.org>  Wed, 02 Aug 2017 17:35:24 -0400
