=== debian/control ===
Source: gall
Section: interpreters
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Daniel Silverstone <dsilvers@digital-scurf.org>
Build-Depends: debhelper (>= 9.20120909~), dh-lua, lua-ldoc, lua-discount,
 lua-luxio, libgit2-dev, git
Standards-Version: 3.9.8
Homepage: https://git.gitano.org.uk/gall.git/

Package: lua-gall
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, git, lua-luxio0
Provides: ${lua:Provides}
XB-Lua-Versions: ${lua:Versions}
Multi-Arch: same
Description: Git Abstraction Layer for Lua
 Gall is a Git abstraction layer for Lua which implements a set of Lua objects
 which can interact with git repositories (via libgit2 where possible).
 .
 Gall allows a Lua program to examine refs and objects, and to fully create
 git commits without needing to create a working tree on disk.

Package: lua-gall-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Documentation for lua-gall
 Gall is a Git abstraction layer for Lua which implements a set of Lua objects
 which can interact with git repositories (via libgit2 where possible).
 .
 Gall allows a Lua program to examine refs and objects, and to fully create
 git commits without needing to create a working tree on disk.
 .
 This package contains the documentation on how to use the Gall library.
