=== debian/watch ===
version=3
https://git.gitano.org.uk/gall.git /gall\.git/snapshot/gall-(.+)\.tar.bz2
